package commonStructures;
import java.util.Scanner;

import enginePackage.*;


public class RestaurantTable {
	private int tableId = -1;
	private Customer tableCustomer = null;
	private Order tableOrder = null;
	
	public RestaurantTable(int anId){
		tableId = anId;
	}
	//public int getId(){return tableId;}
	
	public void authenticateCustomer(AuthenticationManager anAuthMgr){
		Scanner keyboard = new Scanner(System.in);
		System.out.print("Login: ");
		String login = keyboard.next();		
		System.out.print("Passwd: ");
		String passwd = keyboard.next();		
		keyboard.close();
		if (anAuthMgr.authenticate(login, passwd) == 0)
			System.exit(-42);
		else
			tableCustomer = new Customer(this);			//just implemented a two ways relationship:
	}
	
	public Order getOrder(){return tableOrder;}
	public void setOrder(Order o){tableOrder = o;}
	
	public int checkout(TransactionManager tMgr, Order o){
		if(tMgr.checkout(o, tableCustomer) == 1){
			o.setStatus("paid");
			return 1;
		}
		else return 0;
	}
	
	public void plateArrivedAtTable(EPlate pl){
	
		pl.getOrderItemCopy().setStatus("served");

		//now check if the order item is fully served
		OrderItem oi = pl.getOrderItemCopy().getOrderItem();
		if(true == oi.oiIsFullyServed()){ 
			oi.setStatus("served");
		
			//if so, check whether the entire Order is served
			Order o = oi.getOrder();
			if (o.isFullyServed() == true)
				o.setStatus("served"); // TODO: any other check?
		}
	}
}
